function validateRequired(field) {
    if (field.value === null || field.value === "") {
        showInvalid(field, false);
        return false;
    }
    else {
        showInvalid(field, true);
        return true;
    }
}

function validateSelect(field) {
    if (field.value === "0" || field.value === "-1") {
        showInvalid(field, false);
        return false;
    }
    else {
        showInvalid(field, true);
        return true;
    }
}

function validateEmail(field) {
    var reg = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;
    var address = field.value;
    if (reg.test(address) === false) {
        showInvalid(field, false);
        return false;
    }
    else {
        showInvalid(field, true);
        return true;
    }
}

function validateLogin(field) {
    var reg = /^[a-zA-Z0-9\_\-]{3,16}$/;
    if (reg.test(field.value) === false) {
        showInvalid(field, false);
        return false;
    }
    else {
        showInvalid(field, true);
        return true;
    }
}

function validateLoginU3(field) {
    var reg = /^[a-z]{2,4}\-[a-zA-Z0-9\_\-\.]{3,20}$/;
    if (reg.test(field.value) === false) {
        showInvalid(field, false);
        return false;
    }
    else {
        showInvalid(field, true);
        return true;
    }
}

function validatePassword(field, login) {
    if (field.value.length === 0 || field.value === "") {
        //alert("Hasło nie może być puste.");
        showInvalid(field, false);
        return false;
    }

    if (field.value.length < 8) {
        //alert("Hasło jest zbyt krótkie - musi zawierać conajmniej 8 znaków.");
        showInvalid(field, false);
        return false;
    }
    var legalChars = /^[a-zA-Z0-9,.!@#$%^&*]+$/g;
    if (!legalChars.test(field.value)) {
        //alert("Hasło zawiera niedozwolone znaki - dozwolone są małe litery a - z, duże litery A - Z, cyfry 0 - 9 i znaki specjalne ,.!@#$%^&*");
        showInvalid(field, false);
        return false;
    }

    var ns = login.length;
    var min = 3;
    for (i = 0; i < ns - min + 1; i++)
        for (j = i + min; j <= ns; j++)
        {
            var sb = login.substr(i, j - i);
            if (field.value.search(sb) !== -1) {
                //alert("Hasło nie może zawierać fragmentu lub całej nazwy konta użytkownika.");
                showInvalid(field, false);
                return false;
            }
        }
        
        
    var validCategories = 0;
    if (/[a-z]/.test(field.value)) {
        validCategories++;
    }
    if (/[A-Z]/.test(field.value)) {
        validCategories++;
    }
    if (/[0-9]/.test(field.value)) {
        validCategories++;
    }
    if (/[,|.|!|@|#|$|%|^|&|*]/.test(field.value)) {
        validCategories++;
    }

    if (validCategories < 4) {
        //alert("Hasło musi spełniać następujące kryteria: musi mieć przynajmniej osiem znaków, nie może zawierać fragmentu lub całej nazwy konta użytkownika, musi zawierać znaki z czerech kategorii: małe litery a - z, duże litery A - Z, cyfry 0 - 9, znaki specjalne ,.!@#$%^&*");
        showInvalid(field, false);
        return false;
    }
    else {
        showInvalid(field, true);
        return true;
    }
}

function showInvalid(field, isValid) {
    if (isValid)
        field.className = '';
    else
        field.className = 'error';
}

function validateNumbersOnly(element) {
    var unicode = element.charCode ? element.charCode : element.keyCode;
    if (unicode !== 8 && (unicode < 48 || unicode > 57))
        return false;

    return true;
}

function validateFloatNumbersOnly(element) {
    var unicode = element.charCode ? element.charCode : element.keyCode;
    if (unicode !== 8 && unicode !== 46 && (unicode < 48 || unicode > 57))
        return false;

    return true;
}

function validateIP(IPfield) {
    var IPvalue = IPfield.value;
    var ipPattern = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;
    var ipArray = IPvalue.match(ipPattern);
    var isValid = true;


    if (IPvalue === "0.0.0.0") {
        isValid = false;
    }
    else if (IPvalue === "255.255.255.255") {
        isValid = false;
    }
    if (ipArray === null) {
        isValid = false;
    }
    else {
        for (i = 0; i < 4; i++) {
            thisSegment = ipArray[i];
            if (thisSegment > 255) {
                i = 4;
                isValid = false;
            }
            if ((i === 0) && (thisSegment > 255)) {
                i = 4;
                isValid = false;
            }
        }
    }

    if (!isValid) {
        showInvalid(IPfield, false);
    }
    else
        showInvalid(IPfield, true);

    return isValid;
}

function validateFirstName(field) {
    var reg = /^[a-zA-Z0-9ąćęłńóśżźĄĆĘŁŃÓŚŻŹ\-]{2,13}$/;
    if (reg.test(field.value) === false) {
        showInvalid(field, false);
        return false;
    }
    else {
        showInvalid(field, true);
        return true;
    }
}

function validateLastName(field) {
    var reg = /^[a-zA-Z0-9ąćęłńóśżźĄĆĘŁŃÓŚŻŹ \-]{2,28}$/;
    if (reg.test(field.value) === false) {
        showInvalid(field, false);
        return false;
    }
    else {
        showInvalid(field, true);
        return true;
    }
}


function validateUsosPczPassword(field, login) {
    if (field.value.length === 0 || field.value === "") {
        alert("Hasło nie może być puste.");
        showInvalid(field, false);
        return false;
    }

    if (field.value.length < 2) {
        alert("Hasło jest zbyt krótkie - musi zawierać conajmniej dwa znaki.");
        showInvalid(field, false);
        return false;
    }

    showInvalid(field, true);
    return true;
}
